       SecureBlackbox - version 8.1.192 - Released December 10, 2010
---------------------------------------------------------------------------


What's new:

                              [           Legend:          ]
                              [ + Added feature            ]
                              [ * Improved/changed feature ]
                              [ - Bug fixed                ]


^^^^^^^^^^^^^^^^^^^
^^^ Version 8.1 ^^^
^^^             ^^^
^^^^^^^^^^^^^^^^^^^

---
December 10, 2010
Version 8.1.192. Maintenance update

+ (PKI) Added support for PKCS7 files that contain header and footer

* [All] (HTTP) Improved keep-alive support. Now the component attempts to detect the situation when the server has closed supposedly kept-alive connection and reconnect properly.

* [VCL] (ZIP) ElZipWriter can now compress files that are opened with another process

- [All] (PDF) Minor issues with PAdES signature handler and minor issue with PDF document decryption fixed
- [All] (XML) Minor issue with XAdES interface in XMLTimestamp (non-common timestamp) fixed

- [VCL] (Cloud) Fixed authorization issue on Unicode Delphi

---
November 8, 2010
Version 8.1.191. Maintenance update

+ [All] (Base) Added transparent support for reading PEM files encrypted using DES-EDE3-CFB scheme

+ [.NET, VCL] (PDF) Added TinySignerPKCS11 demo
+ [.NET] (SSH) Added VB.NET SSHServer demo

* [.NET, VCL] (Cloud) Added a "fast list" option to TElAWSS3DataStorage component
* [.NET, VCL] (ZIP) Improved performance for large amount of files (10000+)
* [.NET, VCL] (ZIP) Added methods to build archive dynamically
* [.NET, VCL] (PKI) Added possibility to add duplicate certificates to system store using ElSBWinCertStorage

- [.NET, VCL] (Office) Minor issues with binary signature handler for Office documents have been fixed
- [.NET] (SSH) Public-key authentification for DSA keys (broken in build 8.1.189 due to compiler change) has been fixed
- [.NET] (HTTP) The bug with NTLM proxy authentication has been fixed

---
October 4, 2010
Version 8.1.190. Maintenance update

+ [All] (PKI) Added TElSocketTSPClient component which provides support for TCP-based timestamping protocol

* [All] (SSH) Improved compatibility with Mocana SSH server
* [All] (SSL) Improved compatibility with IIS 6 and 7 servers that require client key exchange message to be aligned on RSA modulus length
* [.NET] (SSL) Added possibility to attach SSLSocket components to existing TCP connection
* [.NET] (SSL) Reworked certain parts of SSLSocket code to increase sockets' efficiency
* [AX] (SSL) Added Socks and WebTunnel proxies configuration properties to ElSimpleFTPSClientX component

- [.NET] (HTTPS) Fixed broken parsing of URLs that contained parameters (question mark) and no anchor

---
September 6, 2010
Version 8.1.189. Official Release

+ [All] (PKI) SigningCertificateV2 type is now supported by TElCMSSignature

* [All] (Base) Long (>2Gb) ASN.1 records are now supported
* [All] (PKI) Added support for PEM-enveloped SPC certificates
* [All] (PKI) Added support for buggy TSP servers that provide responses under "application/timestamp-query" content type
* [All] (PDF) Compatibility issue with Adobe Reader when adding more than one attachments to a pdf document

- [All] (Office) Fixed memory leak in OpenDocument component
- [All] (MIME) Fixed mail address parsing bug that sometimes resulted in index out of bounds exception when preparing the mail message
- [.NET] Fixed Silverlight-specific bug - absense of charset object caused NullReferenceException
- [.NET] Fixed the bug in Features parsing (GetFeatures method) which caused the function to throw an exception if CCC was reported in one of the lines.


!!! Build numbers 179-188 skipped due to numbering mistake.  

---
July 24, 2010
Version 8.1.178. Release Candidate 2

+ [All] (PKI) Added possibility to set friendly names for system certificates
+ [All] (PKI) Customized setup of complete validation data in CMS is now supported

- [VCL] (ZIP) Fixed broken string encoding conversion on Unicode-capable Delphi
- [AX] (SSL) Fixed intermittent AV in client-side SSL components


---
July 17, 2010
Version 8.1.177. Release Candidate 1

+ [All] (PKI) Added support for system-driven ("safe") keypair generation 
+ [All] (PDF) Added support for PAdES-compliant signatures
+ [All] (PDF) Added TElPDFSignatureWidgetProps.DateCaptionFormat property to control datetime formatting
+ [All] (Cloud) Added Google Docs data storage component
+ [All] (Cloud) Added enhanced listing capabilities
+ [All] (ZIP) Improved ElZipWriter performance and memory usage for a large number of files
+ [All] (ZIP) Added ElZipWriter.MakeDir & ElZipWriter.AddDirContents methods
+ [All] (EDI) Added support for data compression in AS2 and AS3 protocols

* [All] (Base) Certificate validator opens Windows certificate storages in read-only mode now. This lets validator work correctly under certain limited accounts
* [All] (Base) Proxy errors are now reported in more detail
* [All] (PKI) Improved work with CRLs and OCSP responses in CMS messages
* [All] (SSH) Improved compatibility with 'Internet Server SSHD' and '3.2.0 SSH OpenVMS V5.5 VMS_sftp_version 3' legacy servers
* [All] (PDF) Workaround for non well-formed entries in the cross-reference section (may affect a signed PDF document)
* [All] (MIME) E-mail addresses parsing rewritten

- [All] (PKI) Fixed processing of custom CRL extensions
- [VCL] (SSL) Fixed broken support for some ciphersuites in Delphi 2009 and later


^^^^^^^^^^^^^^^^^^^
^^^ Version 8.0 ^^^
^^^             ^^^
^^^^^^^^^^^^^^^^^^^
---
May 22, 2010
Version 8.0.176. Maintenance update

+ [All] (Cloud) Added Windows Azure storage samples

* [All] (SSH) Added special automatic setup for mod_sftp/0.9 server
* [AX] (PGP) Added support for long (2Gb+) files
* [All] (ZIP) Support for non-ASCII characters in filenames, support for utf8 filenames
* [All] (PDF) Automatically fix documents with truncated document trailer

- [All] (XML) Fixed canonicalization of simple inheritable attributes (like xml:space)
- [All] (XML) Fixed processing of XPath expression with attribute comparing in some cases
- [All] (XML) Fixed canonicalization of processing instructions after XPath transform 
- [All] (XML) Fixed RDN parsing of a quoted attribute value with a comma
- [All] (Office) Fixed signing of document properties for OOXML document
- [VCL] (XML) Fixed minor memory leaks when XPath expression is processed
- [VCL] (ZIP) Fixed some memory leaks
- [AX] (SSH) Memory corruption occured using ElGSSAPIMechanism class for GSS-API/Kerberos V5 authentication


---
May 8, 2010
Version 8.0.175. Maintenance update

- [.NET] Charsets loading has been broken. Due to this, MIME, Office, XML and EDI components could have problems with functioning properly. Fixed. 


---
May 4, 2010
Version 8.0.174. Official release

! [All] The samples are now installed to the All Users\Documents\EldoS directory

+ [.NET] Added Silverlight samples for OpenPGP, PDF, ZIP

- [.NET] Fixed ArrayList sorting issues in Silverlight
- [.NET] Fixed issues with security restrictions that prevented p/invoke in .NET 4.0


---
April 28, 2010
Version 8.0.173. Pre-release version

+ [All] Added DNSSEC support to all socket and socket-based components
+ [All] (ZIP) Added support for addition/removal of files from the existing archive

+ [.NET] Added Silverlight 4.0 assemblies.
+ [.NET] Added .NET Framework 4.0 assemblies
+ [.NET] Added .NET Framework 4.0 project files to sample projects.

* [All] (PDF) Added a workaround for processing documents created by OKI Hotkey software

- [All] (Base) Fixed an intermittent issue with purging of expired cached CRL responses in TElX509CertificateValidator. The problem could cause an Access Violation in VCL and ActiveX edition and deadlock in .NET edition. 


---
April 14, 2010
Version 8.0.172. Beta version

! [.NET] (XML) SBXMLAdES, SBXMLAdESIntf, SBXMLEnc, SBXMLSec, SBXMLSig and SBXMLTransform namespaces have been moved to SecureBlackbox.XMLSecurity assembly
! [.NET, VCL] (XML) Common functions have been moved from SBXMLSec to SBXMLUtils

+ [.NET] Added Silverlight 3.0 assemblies. Silverlight 4.0 support to come later
+ [.NET, VCL] Added CloudBlackbox package (Amazon S3 and simple file storages are initially supported)
+ [.NET, VCL] Added OfficeBlackbox package (Office Binary, Office Open XML, OpenXPS document support)

+ [All] (PKI) Added support for NSS (Mozilla) certificate store access via PKCS#11 interface
+ [All] (PKI) Extended TElMessageEncryptor and TElMessageDecryptor with support for OriginatorInfos and UnprotectedAttributes fields
+ [All] (SSH) Added support for dynamic forwarding to simple forwarding components
+ [All] (SSH) Promoted GlobalKeepAlivePeriod property in simple forwarding components
+ [All] (SSH) TElSimpleSSHClient now supports connecting to a subsystem (besides running a shell and executing a command)
+ [.NET] (PKI) TElX509Certificate now supports casting to and from .NET X509Certificate2 type

* [All] (PKI) Extended TElX509Certificate class with file-based serialization/deserialization capabilities
* [All] (SSH) Improved compatibility with WinSSHD and Tru64 SSH servers
* [All] (XML) Changed a default parameter normalize newline characters on load to true for ElXMLDOMDocument.LoadFromStream method


^^^^^^^^^^^^^^^^^^^
^^^ Version 7.2 ^^^
^^^             ^^^
^^^^^^^^^^^^^^^^^^^

---
March 2, 2010
Version 7.2.171 Maintenance update

- [.NET] Certificate-based encryption of PDF documents got broken in build 169. Fixed.



---
February 23, 2010
Version 7.2.170. Maintenance update

- [.NET] (Base) WebTunneling (HTTPS Proxy) support got broken in build 169. Fixed.


---
February 1, 2010
Version 7.2.169. Maintenance update

+ [All] (Base) Added workaround for buggy HTTP proxies, which sends LFLF instead of CRLFCRLF after reply string
+ [All] (Base) TElRelativeDistinguishedName.SaveToDNString() method has been added
+ [All] (FTPS) Code 230 is accepted now for CWD and PWD commands. 
+ [All] (FTPS) Added Windows style file list parser (tested with ftp.microsoft.com)
+ [All] (EDI) Added HTTP-authorization related properties to AS2 client component
+ [All] (EDI) Added ability to setup verification options before loading a message/receipt
+ [All] (EDI) Added Received-Content-MIC receipt field generation
+ [All] (XML) Added URIStream, URIStreamOffset, URIStreamCount properties for ElXMLReference class
+ [.NET, VCL] (PKI) Added TElX509CertificateEx.AltKeyID property that allows to specify custom key identifier values for PKCS#11-based certificates

* [All] (SSH) Optimized compression subsystem (decreased the amount of used memory, increased decompression speed)
* [.NET, VCL] Improved PKCS#11 on-board keypair/certificate generation routine

- [All] (Base) Fixed minor client-side TSP issue causing intermittent WRONG NONCE errors 
- [All] (EDI) Setting AS2Message.FileModified property did not work
- [All] (SSH) Exit code was not returned correctly in some cases by TElSimpleSSHClient. Fixed.
- [.NET] (EDI) Receipt request options parsing errors
- [.NET] (HTTPS) Bug in URL splitting method
- [.NET] (PGP) Fixed MONO JIT specific issue with loading pgp keys
- [VCL] (HTTPS) Access violation on component destroy if an error occured while establishing a connection

---
December 26, 2009
Version 7.2.168. Maintenance update

+ [All] (Base) Added global IgnoreTagsWhenComparingRDNs flag
+ [All] (SFTP) Added TreatZeroSizeAsUndefined property
+ [All] (PKI) Added tsoIgnoreNonce to TSPClient options (can be useful when working with some buggy servers)

* [All] (Base) SecureBlackbox now understands incorrectly inserted timestamps (TimeStampResp instead of TimeStampToken)
* [All] (Base) Improved JKS format handling
* [All] (EDI) Miscellaneous AS2 components fixes

* [All] (HTTPS) TElHTTPSClient now encodes the path part of the URL if the URL contains spaces in it
* [All] (HTTPS) TElHTTPSClient now includes authentication header when no username is specified and the password is set. Such authentication scheme (password without username) is used by some popular hardware.

---
December 1, 2009
Version 7.2.167. Maintenance update

* [All] (Base) Improved handling of negative X.509 serial numbers
* [All] (SSH) Improved work of X11 forwarding (increased compatibility with several third-party server implementations)
* [All] (SFTP) Added a possibility to omit sending Truncate flag to server when uploading files 

- [All] (SMTP) Error during SSL negotiation sometimes caused TElSMTPClient to hang
- [All] (HTTP) Memory leaks in Digest authentication
- [All] (SSH, SFTP, PDF) ZLib compression didn't work in some cases

---
November 20, 2009
Version 7.2.166. Official Release

! [All] (SSL) Added TLS renegotiation attack prevention mechanisms

+ [All] (ZIP) Added support for wilcard symbols (*, ?) to .Add, .Extract methods;

* [All] (PDF) Improved compatibility with Adobe Reader 9.2 (in a case like adding a second or more signature for hybrid-reference file, or signing an AES-encrypted document)
* [All] (SSH) Increased X11 channels creation compatibility
* [All] (SSL) Improved TLS1.2 compatibility with IIS server
* [VCL] (Base) Improved socket connection errors reporting
* [.NET] (PKI) Improved speed of TElASN1*Tag.SaveToBuffer methods

- [All] (SFTP) Fixed DownloadFiles and UploadFiles methods on Linux: the methods used hardcoded backslash (\) symbol as a path separator. Now platform-specific separator is used.
- [All] (PKI) Fixed SHA2 signing issue with system certificates
- [.NET] (SSH) Fixed DES encryption on SSHv1

---
October 26, 2009
Version 7.2.165. Preview

+ [.NET, VCL] (XML) Added SignatureCompliance property to TElXMLSigner/TElXMLVerifier/TElXMLSignature classes, that enables support of EBICS signature.
+ [All] (ZIP) Added support for BZip2 compression method
+ [All] Added ValidateForTimestamping method to TElX509CertificateValidator class 

* [All] (PKI) Added limitation of ASN.1 tree depth. The maximal depth is now set to 256 by default, but can be changed if needed.
* [All] (PGP) Optimized memory management in TElPGPReader class; added MemoryConsumptionStrategy property
* [All] (SSH) Improved work with certain SSH implementations (reporting themselves as "mod_sftp" and WinFIOL)
* [All] (HTTP) If a connection goes over HTTPS and a proxy server is used but web tunnel is not configured, the component now automatically sets and uses web tunnel properties copied from http proxy properties.
* [.NET, VCL] (XML) Added StrictMode property to TElXMLEnvelopedSignatureTransform class.
* [.NET, VCL] (MIME) Added double quotes to the boundary line for better compatibility with web-mail services. 

- [VCL, .NET] (HTTP) Fixed Basic authentication string formatting which included extra #0 at the end of the text
- [VCL] (PKI) Minor memory leak removed from TElMessageDecryptor class
- [.NET] (ZIP) Fixed some problems with ZIP encryption and archives handling

---
September 16, 2009
Version 7.2.164. Beta version

+ [All] (PKI) Added TElX509CertificateValidator class for automatic complex validation of certificates
+ [.NET, VCL] (ZIP) Added components for ZIP compression and decompression
+ [VCL] Added support for CodeGear RAD Studio 2010

+ [.NET CF] (HTTP) Added NTLM and Digest authentication support
+ [.NET, VCL] (HTTP) Added ForceNTLMAuth property to TElHTTPSClient class
+ [.NET, VCL] (PKI) Added TElX509Certificate.Equals method to compare certificates

! [All] (SSL) Elliptic curve ciphersuites support is now off by default

* [All] (PDF) Improved liberal PDF validation mode
* [All] (PKI) Improved work with Aladdin eTokens and Gemplus cards
* [All] (SSH) Server-side connection handlers have been slightly reworked
* [AX] (PGP) Progress is now reported correctly for large files (>2GB)

- [All] (HTTP) Fixed POST issues when NTLM authentication is used


^^^^^^^^^^^^^^^^^^^
^^^ Version 7.1 ^^^
^^^             ^^^
^^^^^^^^^^^^^^^^^^^

---
August 20, 2009
Version 7.1.163. Maintenance update

* [All] (FTPS) Improved compatibility with VShell server
* [VCL] (PKI) Warnings and hints removed

- [All] (HTTP) Fixed timeout exceeded issue under keep-alive connections
- [.NET, VCL] (PKI) Fixed interface of TElHTTPOCSPClient class (HTTPSClient property was read-only), broken in 7.1.162 build
- [AX] (HTTP) Fixed a bug in GetEx method

---
August 18, 2009
Version 7.1.162. Maintenance update

+ [.NET, VCL] (PDF) Empty signature fields can be now added to the document
+ [.NET, VCL] (SSH) Added means for sending channel EOF before closing the channel
+ [.NET, VCL] (SSL) Added UseSSLSessionResumption property to TElSimpleSSLClient class and its descendants
+ [VCL] (MIME) Added hash algorithm selection in DKIM signer demo

* [.NET, VCL] (PDF) Raw signature body is now accessible via SignatureContents property
* [.NET, VCL] (PDF) Added aoAdjustTimesToUTC document assembly option
* [.NET, VCL] (HTTP) Added ForceKeepAliveIfConnectionHeaderIsAbsent property
* [All] (PKI) Added support for badly encoded CMS SignerLocation attribute

- [All] (MIME) Fixed time zone issue in DomainKeys signature creation time
- [All] (MIME) Fixed bug in relaxed canonicalization algorithm in DKIM

---
July 27, 2009
Version 7.1.161. Maintenance update

! [.NET, VCL] (PKI) TSBOCSPValidationNeededEvent parameter list was extended with URL parameter.
+ [.NET, VCL] (PDF) Added DecryptionMode property. That allows to sign an encrypted document or partially decrypt the document.

* [All] (SFTP) Improved compatibility with Titan MFT and WS_FTP servers
* [All] (SSH) Improved cipher renegotiation compatibility with older OpenSSH servers
* [.NET, VCL] (PKI) URL property has been moved from TElHTTPOCSPClient class to TElOCSPClient class.
* [VCL] (PKI) Win32CryptoProvider is updated to use unicode-enabled routines of Crypto API in Delphi 2009

- [All] (SSH) Fixed minor bug in ElSSHKey generation/loading
- [AX] (PGP) EncryptFile produced AV in use-old-packets mode. Fixed.

- [All] (SSH) TElSimpleSSHClient.ExecuteCommand didn't always return all data, sent by the server. Fixed.

July 8, 2009
Version 7.1.160. Official Release

+ [.NET, VCL] (SSH) Added ExecuteCommand method to ElSimpleSSHClient class
+ [.NET, VCL] (PKI) Added support for on-demand token access mode
+ [.NET, VCL] (PKI) Added pcsoUniqueIDs PKCS11 option to prevent objects with same IDs from being created
+ [.NET, VCL] (PKI) Added support for synchronous slot event monitoring mode
+ [.NET, VCL] (SFTP) Added UseUTF8OnV3 property
+ [VCL] (SSL) Added support classes for kbmMW 3.0 and later. 

* [All] (PKI) Implemented optional Win32 cryptographic context caching (results in significant performance increase of recurrent system certificate-based operations)
* [All] (PKI) Improved compatibility with ActivClient token from ActivIdentity 

- [All] (HTTP) When Gzip compression was enabled, redirection to other resource where both old and new resource were provided with GZip compression could cause "Invalid GZip header" exception. Fixed.
- [All] (HTTP) Fixed a bug in Digest authentication ("MD5-sess" algorithm)
- [All] (PDF) Fixed loading of pdf document with a comment object inside a dictionary object
- [All] (PKI) Fixed minor OCSP response processing issue
- [All] (FTPS) Fixed minor ASCII mode download bug
- [.NET] (MIME) Fixed minor date encoding issue

---
June 7, 2009
Version 7.1.159. Release Candidate 1

+ [All] (PDF) Added support for timestamping of existing signatures
+ [All] (FTPS) Added AccountInfo property, which allows to automatically issue the ACCT command on logon
+ [.NET, VCL] (SSH) Added PKCS#11 key storage component

* [All] (PGP) Added special handling for buggy signatures created with PGPDesktop 9
* [All] (PKI) Improved compatibility with OmniKey tokens
* [All] (SFTP) Improved compatibility with WS_FTP 6 and 7 servers
* [All] (FTPS) Added capabilities of establishing data channel in synchronous way

- [All] (PKI) Fixed bug with JKS loading.
- [AX, VCL] Created a workaround for compiler bug that resulted in intermittent (though quite rare) connection errors
- [AX, VCL] (SSH) Fixed an error in UMAC64 calculation
- [VCL] (SFTP, FTPS) Fixed 2Gb file size limitation on Delphi 4 and Delphi 5
- [VCL] (PKI) Fixed PKCS#11 bugs for Delphi 2009


---
May 25, 2009
Version 7.1.158. Internal build


---
May 18, 2009
Version 7.1.157. Beta version

+ [All] (SSH, SFTP) Added GSSAPI user authentication and key exchange support to client-side components
+ [All] (PGP) Added SFX (self-extracting) files support
+ [All] (PDF) Added AutoAdjustEncoding property for the signature widget
+ [.NET, VCL] (EDI) Added support for AS2 protocol
+ [.NET, VCL] (PKI) Added SetKeyMaterial to TElX509Certificate and TElCertificateRequest classes, allowing to provide a predefined key material for certificate/request generation
+ [.NET, VCL] (All) Added TotalBytesSent and TotalBytesReceived properties indicating the amount of network traffic passed through the component
+ [.NET, VCL] (FTPS) ACCT command is now automatically sent to the server if requested

* [All] (PDF) Improved signature insertion time for extra-large signature objects (big CRLs, OCSP responses or other revocation information embedded to the signature)
* [All] (PDF) Added workaround for pdf documents with incorrect size value in the trailer
* [.NET, VCL] (PKI) Improved work with several cryptographic token models
* [.NET, VCL] (SSH) Added support for choosing a particular network interface to listen for incoming connections in simple remote port forwarding component

- [All] (PGP) Improved support for large (>2Gb) files.
- [All] (FTPS) GetFileTime command could produce an exception when parsing the reply from the server with the date. Fixed.
- [All] (FTPS) Fixed Mode Z upload issue (incorrect compression result)
- [All] (SSL) Fixed handling of server certificate chains consisting of 3+ certificates.
- [All] (PKI) Fixed minor bug in TElCustomCertStorage.IsIssuerCertificate() method (the method occasionally returned False even though the real issuer certificate has been passed to it).
- [All] (SSH) Resolved potential endless loop issue in the simple forwarding components
- [.NET] (HTTP) Fixed bug in NTLM Authentication


^^^^^^^^^^^^^^^^^^^
^^^ Version 7.0 ^^^
^^^             ^^^
^^^^^^^^^^^^^^^^^^^

---
April 20, 2009
Version 7.0.156. Maintenance update

+ [All] (SSH) Added support for providing command exit status
+ [All] (FTPS) Added support for SOCKS and HTTP proxies

* [All] (HTTPS) Added OnSendData event
* [All] (PGP) Improved Get*KeyByEmailAddress() search algorithm
* [All] (SFTP) Improved directory listing compatibility with some SFTP6 client tools
* [All] (FTPS) Improved CCC compatibility with some FTPS servers
* [All] (PDF) Added liberal mode for MDP signature validation

- [AX] Fixed minor certificate storage management-related issue
- [All] (HTTPS) Fixed minor POST'ing issue, which prevented some servers from processing multipart form data correctly

---
March 22, 2009
Version 7.0.155. Official Release

+ [All] (PKI) Added support for CRLs in PKCS12 messages

+ [AX] Added IPv6 support
+ [AX] Added manifest for registration-free COM usage
+ [AX] (PKI, SSH, SFTP) Added support for FIPS-compliant mode
+ [AX] (PKI) Added support for file-based operations
+ [AX] (SSH, SFTP) Added experimental GSSAPI support
+ [AX] (SFTP) Extended SFTP file attributes support
+ [AX] (SFTP) Added support for auto-adjustment of file times after transfer operations
+ [AX] (FTPS) Added concurrent download support
+ [AX] (FTPS) Added support for allowed port ranges configuration

* [All] (SSH) Improved work with HP-UX OpenSSH servers
* [All] (SSH) Improved command execution handling by server-side SSH components
* [.NET] (SFTP) UploadFile opened the local file in read/write mode. This could cause Access Denied error for read-only files or files already opened by other applications. Fixed.
* [.NET, VCL] (PKI) Improved support for long-term CAdES signatures

- [.NET, VCL] (PDF) Fixed encoding and decoding of signature field names
                                                                               
---
March 1, 2009
Version 7.0.154. Release Candidate 1

+ [All] (PKI) Added support for GOST R34.10-1994, R34.11-1994, R34.10-2001, 28147-89 algorithms
+ [All] (PKI) Added TElAlgorithmIdentifier properties and parameters to TElX509Certificate and TElX509CertificateEx
+ [All] (XML) Added new properties to ElXAdESVerifier class for AllDataObjectsTimestamps and IndividualDataObjectsTimestamps
+ [All] (PKI, SSH, PDF, XML) Operations can now be performed in FIPS-compliant mode (on Windows only)
+ [All] (PKI) Added support for signed timestamping requests
+ [All] (SSL, SSH, SFTP, FTPS, HTTPS) Added support for IPv6 protocol

* [All] (SSH) Improved compatibility with Mikrotik 2.9 routers
* [All] (SFTP) Improved file transfer compatibility with a server that identifies itself as SSHD

- [All] (XML) Fixed issue with Base64 transform
- [All] (SSH) Fixed two minor issues in simple forwarding components (timeout and proxy handling for tunneled connections)
- [All] (SSL) Fixed client authentication handling on SSL3

---
February 3, 2009
Version 7.0.153. Beta version

+ [All] (PDF) Added AES256 encryption algorithm supported by Acrobat 9.0 and later. 
  This feature gives you additional level of security for your application.
+ [All] (PDF) Added ElPDFPublicKeyRecipientGroup.KeyEncryptionAlgorithm property

+ [All] (PKI) Added support for CMS-enveloped timestamping requests
+ [All] (PKI) Added support for GOST algorithms to low-level cryptography classes
+ [All] (PKI) Win32 cryptographic provider extended with symmetric and hash algorithms support

- [All] (PDF) Fixed encryption of pdf document for multiple Recipient Groups.

---
January 11, 2009
Version 7.0.152. Beta version

* [All] (SFTP) Improved compatibility with GlobalScape FTP server.
* [All] (SSH) Added support for multiline server identification strings

---
January 1, 2009
Version 7.0.151. Beta version

! Certain PKI functions have been moved to a separate PKIBlackbox package

+ [All] (PKI) Added support for PKCS#11 token insertion/removal notifications
+ [All] (PKI) Added extended cryptographic token support (token-based symmetric and hashing operations are now supported)
+ [All] (SSL) Added support for Elliptic Curve algorithms 

* [All] (PDF) Improved empty signature fields compatibility with Adobe Reader 9
* [All] (FTPS) Improved compatibility with servers that do not shut down SSL gracefully after CCC command


^^^^^^^^^^^^^^^^^^^
^^^ Version 6.1 ^^^
^^^             ^^^
^^^^^^^^^^^^^^^^^^^

---
December 16, 2008
Version 6.1.150. Maintenance update

+ [All] (FTPS) Added support for multipart downloads
* [All] (PDF) Added support for documents with incorrect xref address

- [All] (SSH) Fixed handling of MaxPacketSize in SSH server, caused 'Packet garbled on decryption' error of PuTTY-based SFTP clients (WinSCP).
- [All] (PKI) Minor ECDSA certificate reading issue fixed

- [VCL] (SSH) Fixed minor hangup issue in simple forwarding components


---
November 25, 2008
Version 6.1.149. Official release

* [All] (FTPS) Improved FTP proxy support
* [VCL] (SSH) Removed high processor load in subsystem handler classes


---
November 3, 2008
Version 6.1.148. Beta version

+ Added support for elliptic curves in Certificate & Certificate request demos (VCL, C#, VB.NET)
+ [.NET, VCL] (PDF) Published TElPDFDocument.PDFFile property that provides access to the underlying PDF document structure

* [VCL] (PKI) Added workaround for BCB compiler bug that caused incorrect use of default cryptographic provider leading to various side effects
* [VCL, .NET] (PDF) Improved signature CMS validation
* [All] (PDF) Added workaround for documents generated by Oracle PDF Driver

- [All] (Socket) Another fix of timeout handling
- [All] (FTPS) Fixed CCC+encrypted data channel cooperation bug
- [All] (XML) Fixed parsing of closing tags with spaces at the end
- [All] (XML) Fixed zero-length data handling by TElXMLReference
- [All] (DomainKeys) Fixed verifying and parsing of multiline DKIM-Signature header field
- [.NET] (SFTP) Returned OnTransferCompleted event to the TElSFTPClient class
- [VCL] Fixed SSH IOHandlers for Indy 10.1.5 

---
September 28, 2008
Version 6.1.147. Beta version

+ [.NET, VCL] (FTPS) Added overloaded CCC method
+ [.NET, VCL] (SSH) Added TElSSHServer.BannerSendStage property

* [All] (MIME) Improved speed for assembling message (especially with big attached files).
* [All] (PDF) Improved MDP compatibility with Adobe Acrobat products
* [All] (SSH) Added support for terminal window dimensions change notifications for SSHv1

- [All] (PKI) (PKCS#11) Fixed decryption of data in case if its length is less than the key size (lead zeroes were removed). This applies to Rainbow iKey 1000 security token.
- [All] (PKI) Fixed signing using DSA certificates from Windows System Storage.
- [All] (PKI) Fixed bug in TElX509Certificate.SaveKeyToBufferPEM method
- [All] (XML) Fixed parsing of DOCTYPE tag.
- [.NET] (Socket) Fixed handling of connection timeout.

---
September 11, 2008
Version 6.1.146. Beta version

+ [All] (SFTP) Added support for automatic file times adjustment after transfer operation
+ [All] (XML) Added GetOrder/SetOrder methods to RDNDescriptorMap to control the order of distinguished names formatting in Issuer and Subject of certificate.
+ [All] (XML) Added CompatibilityMode property to RDNDescriptorMap global list. Set it to cmDotNet to emulate .Net formatting of RDN. 

* [All] (PKI) Added method OpenStream to ElAuthenticodeSigner/Verifier.
* [All] (PDF) Improved extraction of signature information (Offset and Size properties)
* [All] (PDF) Some software incorrectly specifies hashing algorithm in adbe.pkcs7 subfilter. Added a workaround in order to validate the signatures with this incorrect algorithm set.
* [All] (PGP) Improved support for encrypted messages, generated by old PGP software.
* [All] (PGP) Fixed some problems with decryption of messages, encrypted with passphrase.
* [All] (SSH) Added w/a for incorrect window size handling by some OpenSSH server versions that might cause session hangup
* [All] (XML) Implemented TElXMLDOMDocument.GetElementByID method.

- [All} (PGP/MIME) PGP MIME handler incorrectly reported an error for multi part messages.
- [All] (SFTP) Fixed upload error handling (in particular, handling of quota exceeded errors)
- [.NET] (Charsets) Fixed parsing issues with ISO-2022-JP charset.

---
August 3, 2008
Version 6.1.145. Beta version

+ [All] (PKI) Added pre-release EC support for X.509 certificates.
+ [All] (XML) Added RDNDescriptorMap global list to control how Issuer and Subject of certificate is formatted

* [All] (SFTP) Improved ASCII mode emulation for SFTP V3
* [All] (SSH) Improved compatibility with Roumen Petrov's X.509 OpenSSH patch

* [All] (PKI) Improved compatibility with Bit4id tokens
* [All] (PDF) Improved extraction of signature information (Page and Invisible properties)

- [All] (PKI) Fixed bug with CRL signing with system certificates
- (MIME) Fixed MIME mail address encoding bug
- [All] (PDF) Fixed signature removing in case if non-existent object is referenced


^^^^^^^^^^^^^^^^^^^
^^^ Version 6.0 ^^^
^^^             ^^^
^^^^^^^^^^^^^^^^^^^

July 3, 2008
Version 6.0.144. Maintenance update

* [VCL] Added possibility of disposing of global objects on application termination
* [All] (SSH) Improved compatibility with old versions of Tectia for Windows server
- [All] (PDF) Fixed reading of the Encrypt entry if it is not an indirect reference
- [All] (SFTP) Fixed big files ASCII mode issue 
- [All] (MIME) Fixed non-ASCII file names corruption
- [All] (PKI) Fixed the problem in TElCertificateRequest, caused writing of all RDN fields as printablestring.
- [AX] (PKI) Destroying the PKCS11 storage without closing it removed all certificates from the storage device. Fixed.

June 15, 2008
Version 6.0.143. Maintenance update

* [All] (SSH) Improved AutoAdjustCiphers mode in SSH components in order to ensure flawless connection with any (even badly behaving) SSH servers
* [All] (PKI) Improved generation of certain certificate extensions
* [.NET, VCL] (XML) Changed the order of some elements in XAdES to follow the schema
* [.NET] (SSH) Updated SSHServerDemo
* [VCL] (SSH) Updated SimpleSFTPDemo demo
* [VCL] (SSH) Improved SynchronizeGUI mode in simple forwarding components

- [.NET, VCL] (PDF) Fixed widget appearance when AutoFontSize and AutoSize set to false.
- [.NET, VCL] (PDF) Fixed TPDFDictionary to distinguish name objects with different case sensitivity.
- [VCL] (PDF) Fixed memory leak when document was closed without saving.
- [.NET] (SMTP) Fixed the error with incorrect parsing of EHLO reply.
- [.NET] (SSH) Fixed problems with hanging sessions in C# SSH/SFTP server sample.

---
May 28, 2008
Version 6.0.142. Maintenance update

- (FTPS) MDTM command returned incorrect date/time due to incorrect parsing of the returned date.
- [.NET] (SFTP) The application could not be closed after transfer due to newly added keep-alive functionality that created a thread. This is a .NET Framework issue, for which workaround has been added.

---
May 23, 2008
Version 6.0.141. Maintenance update


- [.NET, VCL] (SFTP) SSH/SFTP server could report the error when trying to send the data after connection is closed. Fixed.
- (PGP) Fixed loading of armored messages with spaces in header-dividing line.

---
April 29, 2008
Version 6.0.140. Private build.

- [All] (SSH) Fixed compatibility of re-keying operation with some SSH/SFTP servers.

---
April 16, 2008
Version 6.0.139. Minor update.

+ [All] (SFTP) ASCII mode is now supported for SFTP versions prior to 4

* [All] (PDF) Improved compatibility with Adobe Reader 7 with document attachments handling
* [All] (PDF) Document version is now auto-adjusted for encrypted documents

- [AX] (HTTPS, FTPS) Fixed serialization problem in VB6
- [AX] (SFTP) Removed minor resource leakage that might lead to component hangup in some cases
- [All] (MIME) Several message assembling issues fixed

---
April 5, 2008
Version 6.0.138. Maintenance update.

+ [All] (SSH) Added UMAC support
+ [All] (PKI) Added support for RSA2 and SHA2 support to OCSP components
+ [All] (PDF) Added CertIDs property to TElPDFPublicKeySecurityHandler class
+ [.NET] Added Tag property to all the components to allow state storing

* [All] (HTTPS) Now OnPreparedHeaders and OnReceivedHeaders report *all* headers including the previously omited first line of request or response and request cookies.
* [All] (SFTP) Improved file download from servers that do not report file size
* [All] (SSL) Fixed minor DHE key exchange incompatibility between SBB client and OpenSSL server

- [All] (HTTPS) Repaired basic authentication support, broken in build 137.
- [All] (SSL) Fixed minor TLS1.2 version negotiation issue

---
March 15, 2008
Version 6.0.137. Maintenance update.

* [.NET, VCL] (PDF) The documents could not be encrypted and signed using MDP (certification) signature. Now this is possible.
* [.NET, VCL] (MIME) Some software incorrectly specifies hashing algorithm in S/MIME parameters. Added a workaround in order to validate the signatures with this incorrect algorithm set.
- [.NET] PEM decoding was broken. This could lead to impossibility to load SSH keys and PEM-encoded PKI files. Fixed.
- [.NET] In .NET 1.1 Socket class couldn't set KeepAlive option for the socket due to the bug in .NET Framework (the fix was added in .NET 2.0). Workaround for the issue has been added.

---
March 9, 2008
Version 6.0.136. Official release.

+ [All] (SSL) Added StartTLS and StopTLS methods to ElSimpleSSLClient class. These methods let one implement explicit TLS management with ElSimpleSSLClient.

---
March 6, 2008
Version 6.0.135. Internal build.

! Exception classes were renamed to EEl*Error (asterisk denotes the exception own name). 
+ [All] (SFTP) Added simplified ListDirectory method which accepts path as parameter
+ [All] (SFTP) Added an overloaded version of Upload*/Download* methods to support resuming of transfer with possibility to specify restart position

---
February 24, 2008
Version 6.0.134. Release Candidate 2

* [.NET] (SSL) Changes in behaviour of Available property in ElSocket
- [.NET] (FTPS) Active mode was broken by recent change in ElSocket.Bind() method implementation. Fixed. 
- [VCL] (SFTP) Fixed some memory leaks.


---
February 14, 2008
Version 6.0.133. Release Candidate 1


+ [All] (SFTP) Added bandwidth control properties to ElSimpleSFTPClient (AX: properties added only to V6 interfaces)
+ [All] (SSH) Added bandwidth control properties to ElSimpleSSHClient (AX: properties added only to V6 interfaces)
+ [All] (SSL) Added bandwidth control properties to ElSimpleSSLClient, ElSimpleFTPSClient, ElHTTPSClient, ElSMTPClient (AX: properties added only to V6 interfaces)
+ [All] (PDF) Added Rotate property to ElPDFSignatureWidgetProps and ElPDFPageInfo.


---
January 26, 2008
Version 6.0.132. Beta 3

+ [All] (SSH) Added support for OpenPGP authentication in SSH

+ [.NET, VCL] (PGP) Added support for processing multiple files when signing or encrypting the files
+ [.NET, VCL] (PDF) Added possibility to sign attachments to PDF documents
+ [.NET] Added Visual Studio 2008 project files for sample projects

- [.NET] Fixed integration of the components into Visual Studio 2008 IDE
- [AX] Fixed PGPBBox6.dll which could not be properly registered.
- [AX] Included proper .h files in VCWrappers folder.

---
January 19, 2008
Version 6.0.131. Beta 2

+ [All] (HTTPS) Added Digest authentication
+ [.NET] (HTTPS) Added NTLM authentication

+ [.NET] (FTPS) Added RemoteCodePage property to control charset conversion between local and remote systems
+ [.NET] (FTPS) Added OnTextDataLineAsString, OnControlSendAsString, OnControlReceiveAsString events. These events are similar to OnTextDataLine, OnControlSend, OnControlReceive however they contain strings converted from the byte array using RemoteCodePage property
+ [.NET] (SSL) Added ElSSLSocket.CloseSocket() method to close the blocking connection from the other thread.
+ [All] (PKI) Added ElPublicKeyMaterial.LoadFromXML and SaveToXML methods to load and save the keys from/to XML strings.

* [All] (SSH) Improved compatibility of X.509-based authentication with OpenSSH servers
* [All] (SFTP) Improved work with servers which do not return file sizes
* [All] (FTPS) Added a workaround for WS_FTP server which returns incorrect error code in response to FEAT command

- [All] (PKI) Fixed bug in handling signatures using certificates with negative serial number
- [.NET] (HTTPS) Fixed a bug with incorrect request created when request cookies were set

---
December 29, 2007
Version 6.0.130. Beta 1

* [.NET] (SSH) Improved detection of old servers, which don't understand newer encryption algorithms correctly and close connection. 

---
December 3, 2007
Version 6.0.127. Internal build
             
+ [.NET, VCL] (FTPS) Added UseFEATCmd property to ElSimpleFTPSClient. Some servers don't support FEAT command correctly. 

* [.NET, VCL] (PDF) Improved support for non-standard TSP replies

- [All] (HTTPS) Improved handling of code 100 (Continue)
- [All] (HTTPS) In some rare cases OnDocumentEnd could be fired without previous OnDocumentBegin. Now they always come in pairs. 

---
October 18, 2007
Version 6.0.126. Internal build

+ [.NET, VCL] (MIME) Added ElSimpleMIMEAttachment.AttachFile method to attach the data from the file

---
October 18, 2007
Version 6.0.125. Internal build

+ [.NET, VCL] (SSH) Added support for specifying custom order of SSH authentication types to try
+ [.NET, VCL] (SSH) Added support for password change requests
+ [.NET, VCL] (SSH) Several authentication attempts are now supported
+ [.NET, VCL] (SSH) Added keep-alive support to simple forwarding components

* [All] (SSH) Improved compatibility with some buggy servers

- [All] (SSH) Fixed minor bug in simple forwarding components which could lead to session freezing
- [All] (PKI) It was not possible to create a PSS signature with Win32 system certificate. Fixed.


^^^^^^^^^^^^^^^^^^^
^^^ Version 5.2 ^^^
^^^             ^^^
^^^^^^^^^^^^^^^^^^^

---
October 9, 2007
Version 5.2.124. Internal build

+ [.NET, VCL] (MIME) Fixed ElSMTPClient to send EHLO again after SENDTLS as suggested by the RFC

---
October 3, 2007
Version 5.2.123. Maintenance update

+ [.NET, VCL] (FTPS) Added GetNameList method with parameters (to work around the bug of some servers which don't understand NLST command without parameters)
+ [All] (SSH) Added UTF8 support
+ [All] (SSH) Added KbdIntName and KbdIntInstruction properties for accessing corresponding keyboard-interactive authentication parameters
+ [All] (SSH) Added ExitStatus and ExitMessage properties to TElSimpleSSHClient
+ [.NET, VCL] (SSH) Added support for password change requests
+ [All] (SSH) Simple forwarding components: Added support for tunneling of multiple ports through a single SSH connection

* [All] (SSH) Simple forwarding components: Improved speed and CPU usage level
- [All] Fixed a bug in ElSocket.CanSend method which could cause slowdown with some components (including simple SSH port forwarding components)


---
September 25, 2007
Version 5.2.122. Maintenance update

* [All] (SSH, SFTP) Keyboard authentication was not enabled by default in ElSimpleSSHClient and ElSimpleSFTPClient.


---
September 14, 2007
Version 5.2.121. Major update

+ [All] (PKI) Added lcCertificateHash search criteria to TElCertificateLookup

---
September 6, 2007
Version 5.2.120. Release Candidate 3

+ [All] (PGP) Added a constructor TElPGPSignature (Source : ElPGPSignature; CopySigMaterial : boolean), which copies one signature to another for later re-signing
+ [All] (PGP) Added TElPGPSignature.SignatureClass property 
+ [All] (PGP) Added TElPGPSignature.CertificationType property 
+ (SSH) Implemented support for automatic port assignment for simple forwarding components

* [All] (All) Removed several minor memory leaks
* [All] (SSH) Optimized server-side connection handlers
* [VCL] (SFTP) Improved the implementation of TElIdSFTP component

- [All] (PGP) Fixed problems with key and subkey revocation
- [All] (SSL) Implemented correct error handling in cases when the IDEA algorithm support is not available
- [All] (PKI) Fixed key size calculation problem in ElCertificateRequest
- [All] (PKI) Fixed verification of ElCertificateRequest signature for base64-encoded requests. The bug could lead to improper denial of the valid requests.
- [.NET] (FTPS) Fixed socket issue with transferring small files on multi-core CPU.
- [AX] (SFTP) SftpFileAttributesX.UserWrite property could not be set. This could lead to inability to properly adjust file or directory permissions. Fixed.

---
August 28, 2007
Version 5.2.119. Internal build


---
August 16, 2007
Version 5.2.118. Release Candidate 2

+ (PKI) Implemented complete CMS (cryptographic message syntax) support (RFCs 2630, 3126)
+ (PKI) Introduced TElMemoryCRLStorage class
+ (SSH) Added support for keep-alive messages 
+ (XML) Added timestamp methods (till XAdES-A) to XAdES interface classes
* (PGP) Improved ASCII mode support for encrypted messages
* (FTPS) Improved compatibility with some specific servers
* (SFTP) Improved compatibility with some specific servers
* (SSL) Improved compatibility with some specific clients
* (PDF) Improved compatibility with Acrobat-generated certificates
- (PKI) Several minor OCSP bugs fixed


---
July 25, 2007
Version 5.2.117. Release Candidate 1

! [.NET, VCL] DomainKeys changed to DKIM release implementation
+ [VCL] Added C++Bulder 2007 support
* ElGamal algorithm implementation has been significantly improved
* Improved speed of asymmetric cryptography functions
* (PGP) Improved speed of cleartext operations
- (PGP) Fixed cleartext signing issues



---
June 19, 2007
Version 5.2.116. Beta version

+ [.NET, VCL] (SSH) Added support for SSH rekeying initiation
+ [.NET, VCL] (PKI) Added support for PKCS#7 signature timestamping [without performing signing operation]

* [.NET, VCL] (PDF) Improved processing of hybrid-reference PDF documents
* [All] (PKI) Improved compatibility with XEnroll-generated CSRs

- [.NET, VCL] (PDF) Fixed minor PDF decryption issue (several kinds of objects were not decrypted properly)
- [All] (PKI) Fixed minor CSR generation issue (incorrect hash algorithm prefix was used for MD5 and SHA2 requests)


---
June 10, 2007
Version 5.2.115. Beta version

* (All) (FTPS) Improved compatibility with some FTP servers (namely WS_FTP)
- [.NET] (MIME) DayOfWeek was not written properly to a MIME message. FIxed.
- [VCL] (SSH) Server-side components had certain memory leaks. Fixed.

---
June 6, 2007
Version 5.2.114. Beta version

- [All] ElSocket sometimes didn't receive all the data from WebTunneling proxy.
- [.NET, VCL] (PKI) Fixed work with Java Key Store
- [.NET, VCL] (MIME) MessagePart.SetData didn't properly copy the data, if MakeCopy parameter was set to true. Fixed.


---
May 28, 2007
Version 5.2.113. Beta version

+ [All] (SSH) Added notifications about server-side remote port forwarding restrictions
+ [.NET, VCL] (SSL) Added support for OpenPGP authentication in TLS
+ [.NET, VCL] (SSL) Added support for stateless TLS (RFC 4507)
+ [.NET, VCL] (SSL) Added ClientCertStorage property to client-side SSL classes for easier client-side authentication
+ [.NET, VCL] (SSH) Added TElSSHForwardingIntercept class
+ [.NET, VCL] (SFTP) Implemented advanced file removal features (recursive directory deletion and mask-based file removal)

* [All] (SSH) Improved compatibility with some buggy servers
* [All] (SSH) Improved SSH forwarding speed
* [.NET, VCL] (SSH) Added flush-before-close feature to TElSimpleSSHClient
* [All] ElFileCertStorage and ElWinCertStorage attempted to check the license key when the property values were changed in design-time. 

- [All] Fixed ElSocket which could not connect to SOCKS4 server due to a recently made typo mistake


^^^^^^^^^^^^^^^^^^^
^^^ Version 5.1 ^^^
^^^             ^^^
^^^^^^^^^^^^^^^^^^^

---
May 12, 2007
Version 5.1.112. Minor update

!!! Removed IDEA algorithm from standard distribution. IDEA is available as a separate download now.

+ [.NET, VCL] (PDF) Added SignAndEncrypt operation to PDF
+ [.NET, VCL] (PKI) Added ErrorInfo property to TElMessage* classes

* [All] (FTPS) Added compatibility with some servers, which send reply for data channel open command after establishing SSL / TLS on the channel
* [All] (FTPS) MODE Z is now switched when needed and not just during Login
* [All] (SFTP) Improved compatibility with F-Secure SSH server
- [All] (FTPS) Fixed a possible decompression problem if the compressed file had compression ratio of over 32:1

- [.NET, VCL] (XML) Encoding could be omited when writing the XML document. Fixed.
- [.NET, VCL] (XML) Fixed a bug when reading some XML documents, formatted with extra spaces. 

---
May 4, 2007
Version 5.1.111. Minor update

+ [.NET, VCL] (SFTP) Added ExtensionCmd method to ElSimpleSFTPClient
+ [.NET, VCL] (PDF) Added 'adbe.pkcs7.sha1' subfilter to PDF signatures
- [.NET, VCL] (PKI) Fixed reporting of OnProgress event in TElMessageSigner.Countersign method
- [.NET] Now the assemblies can be loaded to MS SQL Server 2005
- [All] (PGP) Revoked property of the key was not always loaded from the key data

---
April 26, 2007
Version 5.1.110. Major update

* [.NET, VCL] (PKI) Implement TElMessageSigner.Countersign(Stream, Stream) method correctly 
* [.NET, VCL] (PKI) Implement support for 64 bit streams for TElSymmetricCrypto
- [AX] (SFTP) Fix miscellaneous errors in SimpleSftpDemo (ActiveX/VC++) 
- [.NET, VCL] (XML) Problems decrypting 3DES-encrypted document on Windows 2000

---
April 11, 2007
Version 5.1.109. Release Candidate 1

+ [All] (SSL) Added SRP (Secure Remote Password) cipher suites

+ [All] (FTPS) Added support for MLSD (machine-parseable list directory) command

+ [.NET, VCL] (SSL) Added Datagram TLS client and server

+ [.NET, VCL] Added License Manager component to store the license key in it

+ [AX] (SSL) Added FTPS and HTTP clients

- [.NET, VCL] (PKI) Fixed design-time editing of Certificate Storages
- [.NET, VCL] (MIME) Fixed attachment processing in ElSimpleMIME class

- [.NET] (MIME) Fixed various .NET-specific issues caused by change of the compiler in SecureBlackbox 5

---
March 22, 2007
Version 5.1.108. Beta version

! [.NET] (SSL) El*SSLSocket classes now support on-the fly changing of SSL mode with automatic handshake carried when SSLEnabled is set to true.

+ [.NET, VCL] (XML) Added support for XAdES-T for digital timestamping of the XML signatures

* [.NET, VCL] (XML) Improved behavior of ElXMLVerifier.RemoveSignature method. Now it can remove both enveloping and enveloped signatures.

* [VCL] (PKI) Improved Authenticode components to work with 64-bit PE files.

- [.NET] (PKI) Fixed cryptoprovider classes to provide correct garbage collection of keys and hash contexts
- [.NET, VCL] (XML) Fixed the issue with incorrect quote (") character conversion during canonicalization



^^^^^^^^^^^^^^^^^^^
^^^ Version 5.0 ^^^
^^^             ^^^
^^^^^^^^^^^^^^^^^^^


---
February 25, 2007
Version 5.0.107. Minor update

! [All] (SSH) Changed the way ElSimpleSSHClient.ReceiveData method works. Now the method returns as soon as any data are read.

+ [All] (SSH) added support for HMAC-SHA2/RIPEMD
+ [All] (PKI) added support for HMAC-SHA2 to SBMessages and S/MIME
+ [All] (PGP) added support for SHA2/RIPEMD hash algorithms for cleartext signing/verifying

+ [AX] (SSH) Added Commands property to ElSimpleSSHClientX
+ [AX] (SSH) Added an overload for ReceiveText method to ElSimpleSSHClientX
+ [AX] (SSH) Added CanReceive method to ElSimpleSSHClientX
+ [AX] (SSH) Added VBScript sample for ElSimpleSSHClientX

---
February 11, 2007
Version 5.0.106. Minor update

+ [All] (PGP) Added some properties to PGPReader to get information about the encrypted or signed data.
+ [All] (SFTP) Added FileExists method to check file presense. 

+ [AX] (PGP) Added recent properties of ElPGPCustomSecretKey and ElPGPCustomPublicKey to ActiveX controls
+ [AX] (SFTP) Added ReadDirectoryAsString and ReadDirectoryAsStringList to ElSimpleSftpClientX class for use in FoxPro and scripting environments.

+ [.NET, VCL] (SSH) Added OnSendCommandRequest event to track, what command of the Commands property is being executed next.

- [All] (PGP) Fixed clear-text signing of the text, which doesn't contain end-of-line characters (i.e. consists of just one line of text). 
- [All] (SSH) Multiple commands in Commands property didn't work. Fixed.
- [All] (HTTPS) Fixed the incorrect formatting of Cookie header.

- [.NET] (HTTPS) Fixed the issues with wrong command being called under .NET CF 1.0.
- [.NET] (MIME) Date/time timezone offset was not written properly. Fixed.
- [.NET] (MIME) Content charset parameter was not set due to compiler bug. Fixed (using a workaround).
- [.NET] (Base) Fixed Socks and WebTunneling connections via ElSocket, broken due to change of compiler.

---
January 27, 2007
Version 5.0.105. Minor update

+ [AX] (SFTP) ASCIIMode added to ElSimpleSFTPClient using IElSimpleSFTPClientX4 interface.
+ [All] (SSH) Added the possibility of executing remote commands without requesting a terminal

* [All] (SSH) Improved compatibility with SSH Extreme Router

- [All] (PGP) Enabled property of the key was not copied when the key was duplicated.  Fixed.
- [All] (PGP) If the file has more than one armored block, only the first block was loaded. Fixed.
- [All] (HTTPS) If the server reported a relative path in Location: field of 302 (Object Moved) response, the new path was not correctly re-created as an absolute path. Fixed.

- [.NET] (SSH, SFTP) The prompt dialog for keyboard authentication didn't work in most of the samples due to non-functioning OK button. Fixed.
- [.NET] (SFTP) UploadFiles could insert a backslash to the beginning of the file name. The bug appeared in SBB 5 due to change of compiler. Fixed.
- [.NET, VCL] (XML) Fixed processing of ampersand when saving the file

- [VCL, AX] (PKI) Memory corruption occured when trying to load the CER (certificate) file over 4KB large, or use ElX509Certificate.DetectCertFileFormat() method on such file. Fixed.

---
December 25, 2006
Version 5.0.104. Official Release

+ [All] (OpenPGP) Added DSA2 support
+ [All] (PKI) Added HMAC-SHA2 support

* [.NET, VCL] (FTPS) Improved error handling during data transfer
* [.NET, VCL] (XML) Changed some TElXMLDOMDocument methods for easier use of DelayLoadModes.

- [.NET, VCL] (FTPS) Fixed the problem with upload speed (broken in one of previous builds)

---
December 16, 2006
Version 5.0.103. Release Candidate 2

---
December 9, 2006
Version 5.0.102. Release Candidate 1

* (PDF) PDF classes now process the data without loading them completely to memory

* [.NET] SecureBlackbox can now be used from partially trusted assemblies
* [All] (SSH) Keyboard-interactive authentication is now handled automatically, if nothing was handled by the application. This is done by passing a password.

- [All] (PDF) several miscellaneous minor errors fixed
- [All] (SSH) fixed remote port forwarding functionality (broken in the previous build)
- [All] (SSH) fixed thread-safety problem in simple forwarding components

---
November 10, 2006
Version 5.0.101. Beta version

* [.NET] (FTPS) Fixed the issue with parsing FEAT reply from the server


---
November 6, 2006
Version 5.0.100. Beta version

+ [All] (PKI) Added stMemory storage type in ElWinCertStorage class. 

* [VCL] Improved nag screen display behaviour to not show the nag screen in design-time

* [.NET, VCL] (FTPS) Improved MODE Z request sending

- [All] Fixed socket class, which could not be reused if previous connect attempt failed under certain circumstances.
- [All] (PKI) Fixed ElWinCertStorage.Add method when it was used to add the certificate to registry or LDAP stores.

- [VCL] Fixed various C++Builder-specific issues which happened due to compiler bugs
- [.NET] (SFTP) SimpleSFTPClient.MessageLoop event was not working correctly. Fixed. 
- [.NET] (SSL) Updated RemObjects InternetPack classes and samples
- [.NET, VCL] (FTPS) Fixed the data transfer abort procedure


---
October 19, 2006
Version 5.0.99. Beta version

+ [All] (PKI) Added support for unencrypted private keys in PFX files
+ [All] (PKI) Added support for DSA2 algorithm
+ [All] (PKI) Added support for id-ea-rsa algorithm in certificates
+ [.NET, VCL] (OpenPGP) Added algorithm properties to PGP/MIME classes. 
+ [.NET, VCL] (PDF) Added support for the documents with encrypted object streams
+ [.NET, VCL] (PKI) Added improved support for countersignatures
+ [.NET, VCL] (PKI) Added ElPKCS11Manager class
+ [.NET, VCL] (PKI) Added support for Java KeyStore format in certificate storages

+ [All] (SSH) Added support for keep-alive signals
* [.NET, VCL] (HTTPS) Username and password can now be specified in the URL
* [.NET, VCL] (PKI) Added compatibility with several types of PKCS#11 tokens
* [All] (SSH) Added workaround for compatibility with Tectia clients
* [.NET, VCL] (PDF) Added workaround for greater signature compatibility with Adobe Acrobat software

- [All] (Base) Fixed minor bug in Elgamal implementation
- [.NET, VCL] (PDF) Fixed minor bug in PDF certificate encryption
- [.NET, VCL] (HTTP) Multiple cookies, set using RequestCookies, were sent to the server incorrectly. Fixed. 
- [.NET, VCL] (PDF) Fixed minor bug in PDF certificate encryption
- [.NET] (Base) Fixed minor bug in Serpent implementation
- [All] (SFTP) Fixed minor bug in ElSimpleSFTPClient.DownloadFile method
- [AX] (SFTP) Fixed minor bug in ElSftpClientX.RemoveFile method
- [AX] (PKI) Fixed minor bug in certificate request processing

---
September 19, 2006
Version 5.0.98. Beta version

+ [.NET, VCL] (PDF) Added read-only support for the documents, which are both signed and encrypted.
+ [AX] Added ElSocketX class
+ [.NET, VCL] (FTPS) Added passive mode IP address adjustment for NATted servers

* [All] (PKI) Improved work with huge (over 2Gb) documents in PKCS#7 (SBMessages)
* [All] (OpenPGP) optimized decryption code

- [All] (OpenPGP) fixed several memory leaks in key management routines
- [.NET, VCL] (MIME) fixed several MIME parsing problems
- [.NET, VCL] (HTTP) fixed minor hangup issue
- [All] (PKI) fixed minor CRLDistributionPoints writing error
- [All] (FTPS) Fixed the issue with passive mode and some servers, which erroneously send 226 during Receive procedure before the actual transfer takes place. 
- [All] (SSL) ElSimpleSSLClient (and also ElSMTPClient and ElHTTPSClient) could go into an infinite loop in certain conditions, if SSL handshake could not be completed. Fixed.

---
September 2, 2006
Version 5.0.97. Beta version

! [.NET, VCL] FTPS and HTTPS are now part of SSLBlackbox Client-Only package.

+ [.NET, VCL] (FTPS) Added MODE Z (compression) support
+ [All] (OpenPGP) Added TElPGPPublicKey.PrefferedSymAlgs/TElPGPPublicKey.PrefferedSymAlgCount, TElPGPPublicKey.PrefferedHashAlgs/TElPGPPublicKey.PrefferedHashAlgCount, TElPGPPublicKey.PrefferedComprAlgs/TElPGPPublicKey.PrefferedComprAlgCount properties
+ [AX] (SSL) Added IElSimpleSSLClient interface with ReceiveDataEx method

- [.NET] (SFTP) DownloadFiles and UploadFiles didn't work due to the error in file name handling code. Fixed.
- [.NET] (OpenPGP) Fixed error in SBPGPMD, which caused SHA2/RIPEMD hashes to work incorrectly.
- [VCL] (SSH) Fixed critical error in TElSSHServer, which caused incorrect DSA signature generation.

---
August 13, 2006
Version 5.0.96. Beta version

+ [.NET] (PKI) PKCS#11 support added

- [AX] (SSH, SFTP) Some components could not be created in ASP environment. Fixed.
- [.NET] (SFTP) File Attribtes were not always obtained correctly. Fixed.

August 6, 2006
Version 5.0.95. Beta version

! TSBCertificateValidity and TSBCertificateValidityReason types have been moved from SBCustomCertStorage to SBX509.

+ [.NET, VCL] (MIME) Added TElSimpleMIMEMessage class for easy creation of mail messages. Also added TElSimpleSMIMEMessage and TElSimplePGPMIMEMessage message for S/MIME and PGP/MIME accordingly.
+ [.NET, VCL] (MIME) Added TElSMTPClient component for mail delivery. Requires SSLBlackbox Client-Only or other licenses (which include SSLBlackbox Client-only) for use.
+ [.NET, VCL] (FTPS) Added support for SIZE command to obtain the size of the file being downloaded (in order to report correct OnProgress values).
+ [.NET, VCL] (PKI) Added TElX509CertificateChain class which represents a certificate chain. End-entity certificate has the index of 0, it's CA has index 1 and so on.
+ [.NET, VCL] (PKI) Added TElCRLDistributionPointExtension.Included property, which controls which of object's properties should be written to the certificate.
+ [.NET, VCL] (PKI) Added support for Authenticode timestamping to TElTSPServer classes
+ [VCL] (PKI) Added support for Authenticode timestamping to TElAuthenticode* classes

* [All] (SSL) Improved the process of OnCertificateValidate and OnCertificateNeededEx event invokation
* [All] (OpenPGP) Improved PGP operation speed.
* [All] (OpenPGP) Changed TElPGPSecretKey.EndGenerated method - added  UseOldFormat parameter.
* [All] (OpenPGP) Added TElPGPPublicKey.Version and TElPGPSecretKey.Version properties.
* [.NET, VCL] (SSH) Added EOLMarker parameter to TElSSHKey.SavePublicKey. The parameter allows to specify the type of EOL marker (CRLF, CR, LF)
* [.NET, VCL] (HTTP) Added RequestCookies and ResponseCookies properties to TElHTTPSClient

- [All] (PKI) Signing, decryption and some key exchange operations with a certificate, located in LocalMachine Windows certificate storage with non-exportable private key didn't work. Fixed.
- [All] (OpenPGP) Fixed compatibility with non-standard PGP 8.1 photo packet.
- [AX]  (OpenPGP) TElPGPReader.OutputStream property didn't work. Fixed.
- [.NET, VCL] (PKI) Fixed various minor standard-compliancy bugs in TSP components
- [.NET, VCL] (PKI) Fixed various minor standard-compliancy bugs in OCSP components



^^^^^^^^^^^^^^^^^^^
^^^ Version 4.4 ^^^
^^^             ^^^
^^^^^^^^^^^^^^^^^^^


---
July 20, 2006
Version 4.4.0.94. Minor update.
- [All] (OpenPGP) Fixed the hanging in DecryptAndVerify() method.
- [All] (OpenPGP) Fixed the problem with TElPGPSecretKey.Passphrase property being reset unexpectedly

---
July 16, 2006
Version 4.4.0.93. Minor update.

+ [All] (SSH) FSecure private key format is supported.
* [All] (SSH) Connecting to Tectia 5 servers didn't work due to the bug in the server. Workaround added.
- [.NET] (PKI) OCSP client request didn't include a signature and responder name. Fixed.

---
July 12, 2006
Version 4.4.0.92. Minor update.

* [All] (PKI) Now TElX509Certificate.LoadFrom*SPC and TElX509Certificate.LoadFrom*PFX attempt to load the end-entity certificate, if more than one certificate is present in the input data.
* [All] (PKI) Now base64-encoded certificate, certificate request and CRL files are detected and loaded.
* [All] (SSH) SSH.com private keys, converted by F-Secure (from their private format) could not be loaded. Fixed.

- [All] (SFTP) Downloading and uploading of 0-byte-long files in synchronous mode or using TElSimpleSFTPClient was fixed (didn't work since build 90)
- [.NET] (SFTP) File renaming didn't work with SFTP versions 5 and 6. Fixed.

---
July 9, 2006
Version 4.4.0.91. Minor update.

! [.NET, VCL] (OpenPGP) Parameters of OnProgress event have been changed to support 64-bit files. Current code will be broken, unfortunately.

+ [VCL] (SSL) Added RealThinClient helper classes for SSL support
+ [AX] (SFTP) Added IElSimpleSFTPClientX3 interface (ElSimpleSFTPClientX class now implements this interface),
  which provides access to recently added properties andd methods of ElSimpleSFTPClientX
+ [All] (SFTP) Added DownloadFiles/UploadFiles and DownloadStream/UploadStream methods to TElSimpleSFTPClient

* [All] (PKI) Added ReplyCertificates to OCSP client
* [.NET, VCL] (OpenPGP) Improved work with huge (over 2Gb) files

- [All] (PKI) Fixed two minor bugs in OCSP client reply parser
- [.NET] (OpenPGP) Fixed a bug with validating detached and clear-signed signatures
- [All] (PDF) Fixed a bug with signing a document with timestamping, when timestamp server returned large timestamp.
- [All] (PDF) Fixed a bug with signing a document with timestamping, when timestamp client returned an error.

---
June 25, 2006
Version 4.4.0.90. Minor update.

+ [.NET, VCL] (FTPS) Added CCC (Clear Command Channel) command.
+ [.NET, VCL] (PKI/HTTP) Added HTTP OCSP client to HTTPSBlackbox

* [.NET, VCL] (SFTP) improved SFTP download speed again
* [.NET, VCL] (SFTP) improved compatibility with various SFTP servers

* [All] (PKI) Now TElX509Certificate.LoadFrom*() detects and handles Base64-encoded certificates (not PEM-formatted!)

* [All] (PKI) Re-implemented OCSP client and server in order to achieve better standard conformance.

- [.NET, VCL] (SFTP) fixed attribute-handling bugs in SFTP server
- [.NET, VCL] (FTPS) Active mode got broken in build 86. Fixed.
- [.NET] (PKI) problem with opening System Certificate Storages on .NET CF were fixed.
- [.NET, VCL] (OpenPGP) Fixed writing of armoured keyrings.

---
May 31, 2006
Version 4.4.0.89. Minor update.

+ [.NET, VCL] (PKI) Added DefaultPolicy property to TSP server.

- [.NET, VCL] (PKI) Fixed reading of PEM files with CRLF and LF mixed in a single data block.
- [.NET, VCL] (PKI) Fixed certain Nonce- and Accuracy-related problems with TSP server.
- [.NET] Fixed the problem with table-based charsets in SecureBlackbox.Charsets assembly.
- [VCL] (SFTP) Fixed the memory leak, introduced in build 88 when uploading or downloading the files.

---
May 24, 2006
Version 4.4.0.88. Minor update.

! [All] (SFTP) Dramatically improved speed of file upload/download

+ [.NET, VCL] (SFTP) Added certain properties (UploadBlockSize, DownloadBlockSize, PipelineLength) for better control of upload/download operation speed

* [.NET, VCL] (PKI) Added a workaround for handling reformatted MessageImprint, returned by some TSP servers.

* [AX] (SSH) ElSSHKeyX.Headers now returns IUnknown (which you need to cast to IElStringListX)

- [All] (SFTP) Fixed possible error, which could happen when the network connection is closed in SimpleSftpClient
- [All] (OpenPGP) Read-only secret key could not be loaded from keyring correctly due to a problem with setting Expires field.
- [AX] (SSH) ElSimpleSSHClientX.MessageLoop event was not correctly fired if no handler was attached. Fixed.
- [AX] (SSH) ElSSHKeyX could not be viewed in Watch window of Visual Basic. Fixed.

---
May 18, 2006
Version 4.4.0.87. Internal update

---
May 16, 2006
Version 4.4.0.86. Major update.

+ [.NET, VCL] (SSL) Added ElSimpleSSLClient.CanReceive() method.

* [All] (PKI) Now no exception is raised if the loaded certificate contains unknown algorithms
* [.NET, VCL] (PDF) Added an exception which is raised during attempt to apply MDP signature to the document with templates. Previously incorrect signature was applied.
* [.NET, VCL] (PDF) Improved signing of certain documents.
* [.NET] (SSH) Fixed saving of SSH public key in OpenSSH format. Previously the prefix ended with 0x0 character, and this confused users.
* [AX] (PKI) Now text-form OIDs can be passed to IElRelativeDistinguishedNameX.SetOID

- [AX] (PKI) Fixed ElRelativeDistinguishedName class to write text data as PrintableString (otherwise the text is not displayed by Windows Certificate Manager)
- [All] (PKI) Fixed TElRSAKeyMaterial which incorrectly saved PEM-encoded private key
- [All] (PKI) Fixed ASN.1 writer which saved large integer values with leading zero (thus confusing some inflexible software like the one from RSA Security)
- [All] Fixed the bug in ElSocket, which prevented connection of the socket, if LocalAddress was set for outgoing socket.

---
May 7, 2006
Version 4.4.0.85. Major update for ActiveX.

- (PKI) Fixed TElRSAKeyMaterial which incorrectly saved PEM-encoded private key
- (PKI) Fixed ASN.1 writer which saved large integer values with leading zero (thus confusing some inflexible software like the one from RSA Security)

---
April 30, 2006
Version 4.4.0.84. Release candidate.

+ [AX] (OpenPGP) Added PGPBlackbox to ActiveX edition. PGPBlackbox/AX is now in beta since ActiveX/VB6 declarations are not present in documentation.

* [.NET, VCL] (PDF) Added possibility to Base16-encode the textual data in PDF signatures to avoid certain compatibility and charset management problems.
* [.NET, VCL] (PDF) Added possibility to change appearance of existing signature fields.
* [.NET, VCL] (SSH, SFTP) Now keyboard-interactive authentication can optionally be tried as the last authentication attempt (instead of the first, as before).
- [VCL] (SSH, SFTP) minor fixes in SSH Indy IOHandlers.

---
April 19, 2006
Version 4.4.0.83. Beta version.

! [.NET] Changed installation procedures and deployment instructions

! [.NET, VCL] Introduced new supplementary Charsets package (SecureBlackbox.Charsets assembly in .NET and ChsBBox in VCL).

+ [.NET, VCL] Added XMLBlackbox package to SecureBlackbox Professional
+ [.NET, VCL] Added BZip2 support (currently used in PGP)

- [AX] (SSH, SFTP) Fixed a problem with accessing certain objects (SftpFileInfoX, SSHKeyX) from scripting environments or when using Variants (i.e. via IDispatch).

---
April 13, 2006
Version 4.4.*.82. Beta version.

! Speed optimization in most symmetric encryption algorithms

+ [.NET, VCL] (SSH) Added SimpleSSHPortForwarding components
+ [.NET, VCL] (PKI) Added asynchronous operations in ElX509Certificate (generation)
+ [.NET, VCL] (OpenPGP) Added asynchronous operations in PGP (key generation and signing / encryption)

- [.NET, VCL] (HTTPS) Fixed certain authentication issues (including NTLM POST/PUT problems).
- [VCL] (SSH, SFTP) Fixed IndySSH and IndySFTP classes which wwere not properly created in Indy 10 in design-time

---
March 31, 2006
Version 4.3.0.81. Minor update for ActiveX.
- [.AX] (SSH, SFTP) Fixed keyboard authentication in SSH client

---
March 29, 2006
Version 4.3.*.81. Release for .NET CF and Mono.

- [.NET] Fixed some resource leaks.

---
March 24, 2006
Version 4.3.1.80. Release Candidate for .NET CF and Mono.

---
March 11, 2006
Version 4.3.80. Minor update.

+ [VCL, .NET] (PKI)  Added high-level classes for symmetric encryption
+ [.NET] (PKI)  Fixed certain ASN.1 issues, that caused some certificates to be written incorrectly
+ [AX] (SFTP) Added C++ and VB samples for SimpleSFTP component

- [AX] (SFTP) Fixed the access violation error which happened upon reconnection
- [VCL, .NET] (FTPS) Fixed some bugs in FTPS handling of the Passive mode
- [VCL, .NET] (HTTPS) Fixed a bug for 100-Continue response code handling
- [VCL, .NET] (OpenPGP) Fixed minor bug in PGP keys (Expires property was not initialized).


---
February 20, 2006
Version 4.3.79. Major update.

!!! [.NET]
!!!
!!! Due to possible assembly conflicts in .NET 2.0, additional assemblies have been introduced.
!!!
!!! SecureBlackbox.SSLCommon is now required by SecureBlackbox.SSLClient, SecureBlackbox.SSLServer, SecureBlackbox.SSLSocket
!!! SecureBlackbox.SSHCommon is now required by SecureBlackbox.SSHClient, SecureBlackbox.SSHServer, SecureBlackbox.Sftp, SecureBlackbox.SFTPServer
!!! SecureBlackbox.SFTPCommon is now required by SecureBlackbox.Sftp, SecureBlackbox.SFTPServer
!!!

+ [VCL, .NET] Now it's possible to globally disable patented IDEA algorithm

+ [VCL, .NET] (PDF) Now PKCS#1 signing is supported by PDF signer
+ [VCL, .NET] (PDF) Added timestamping capabilities to PDF signer
+ [VCL, .NET] (PKI) Added timestamping capabilities to ElMessageSigner
+ [VCL, .NET] (PKI/HTTPS) Added HTTP Timestamping Protocol Client component
+ [VCL, .NET] (SSL) Added TLS extensions

- [.NET] Fixed PEM.Decode function which in certain cases incorrectly handled encrypted PEM data.
- [All] (PKI) Fixed ElX509Certificate which didn't handle some EFS certificates correctly.

---
January 28, 2006
Version 4.3.78. Beta version.

+ [VCL, .NET] (HTTPS) Added HTTP / HTTPS client component
+ [VCL, .NET] (PKI) Added Timestamping Protocol components
+ [VCL, .NET] (PKI) Added higher-level classes for RSA encryption and signing and for DSA signing
+ [VCL, .NET] (SSL) Added pre-shared key cipher suites

* [All] (PKI) Now when the data is signed with TElMessageSigner, and AuthenticatedAtributes are added, hash is written according to CMS specification. Previously the application had to write the hash itself (as defined in PKCS#7).

- [VCL, .NET] (OpenPGP) AES 256 was disabled. Fixed.

---
January 18, 2006
Version 4.2.77. Minor update.

+ [VCL, .NET] (PKI) Added SBPEMProcessor class for PEM encoding/decoding operations.

- [All] (SSL) Fixed SetLicenseKey method which prevented server-side TLS 1.x from working properly.
- [VCL, .NET] (PDF) Fixed an issue with PDF document signatures when multiple certificates were passed to the signing handler.

---
January 13, 2006
Version 4.2.76. Minor update.

+ [All] (SSH) Added new key exchange algorithm: SSH_KEX_DH_GROUP_14
+ [VCL, .NET] (PKI) Added methods for loading/saving many certificates to/from PKCS#7 format to ElCustomCertStorage class. Note, that only binary PKCS#7 files are handled (i.e. not base64-encoded).

- [All] Fixed MD2 support
- [All] Fixed ElSharedResource implementation which could lead to problems with high multithreaded load on certificate storages, key storages and some other thread-safe classes.
- [VCL, .NET] (FTPS) Fixed passive mode operations.
- [VCL] (SSH) Fixed LocalPortForwarding demos
- [.NET] Fixed installer which failed on the systems, which didn't have .NET Framework SDK 1.1 installed

---
December 24, 2005
Version 4.2.75. Minor update.

!!! [VCL, .NET]
        (SSL) Certain event type declarations have been moved from SBClient and SBServer to SBSSLCommon.
        SBClient.TSBValidateCertificateEvent has been renamed to SBSSLCommon.TSBCertificateValidateEvent.
        Please see sample applications for details about the changes made.

! [VCL] (SSL) SSLBBoxCli*.dpk packages have been added. Client-side SSL components have been moved from SSLBBoxSrv*.dpk to these new packages.
  You need to install SSLBBoxCli*.dpk as well as SSLBBoxSrv*.dpk.
+ [VCL, .NET] (SSL) Added compression to SSL client and server

---
December 18, 2005
Version 4.2.74. Minor update.

* [VCL, .NET] (PDF) Added support for signing and decryption with non-exportable private keys, contained in Windows Certificate storage or in PKCS#11 storages.
* [AX] (SSH) Fixed key validation routine
* [.NET] (SSH) Added SSH Server sample for C#

---
December 08, 2005
Version 4.2.73. Major update.

+ [VCL, .NET] (FTPS) Added FTP / FTPS Client component.
+ [VCL, .NET] (SFTP) Added SFTP 5 and SFTP 6 support.
+ [VCL, .NET] (SFTP) Added OnProgressEvent to ElSimpleSFTPSClient.
* [All] (SSH) Fixed key re-exchange problems.
- [VCL, .NET] (PDF) Fixed various bugs (mainly compatibility problems).

---
November 14, 2005
Version 4.1.72. Minor update (.NET edition only)

+ Added .NET 2.0 and Mono support. Note, that support is provided in a separate, "experimental" installation. .NET CF support is to come later.

+ (PDF) Fixed some signing issues with large files.
* (PKI) Generated certificates were not loaded by Java 1.4.x due to Java bug. Workaround added.

---
October 22, 2005
Version 4.1.71. Major update

+ [VCL, .NET] (PDF) PDFBlackbox released
+ [All] (OpenPGP) Added support for V3 secret keys encrypted with CAST5, Blowfish and AES128
+ [All] (SSL) Added support for Camellia ciphersuites
* [VCL, .NET] (SFTP) Added TElSftpClient.UseUTF8 and TElSimpleSftpClient.UseUTF8 properties.
* [All] (OpenPGP) Added TElPGPReader.Passphrase and OutputStream properties
- [All] (OpenPGP) ElPGPKeyring raised an exception on empty keyrings. Fixed.

---
October 6, 2005
Version 4.1.70. Beta version

+ [VCL, .NET] (PDF) PDFBlackbox BETA released
+ [VCL] (SSL) Added ElSecureServerSocket demo application
- [VCL] (SSL) Fixed a problem with ElSecureServerSocket.OnClientDisconnect event (the event did not fire)
- [VCL] (SSL) Fixed minor memory leak in ElSessionPool class
- [VCL] (PKI) Fixed minor error in ElPKCS11CertStorage component (illegal token removal case)
- [All] (SSL) Fixed minor error in server-side SSL classes (bad handshake with some Java clients)

---
October 1, 2005
Version 4.0.69. Minor update

- (Help) MS Help 2.0 documentation didn't show keyword index correctly. Fixed.
- [.NET] (SSL) Fixed an error that prevented SSLSocket from working correctly in asynchronous mode.
- [VCL] (PKI) Fixed memory leak in ElX509Certificate.LoadFrom* methods.
- [AX] (SSL) Fixed certificate processing error in ElSecureServerX.
+ [All] (PKI) Added support for RSASSA-PSS and RSA-OAEP algorithms

---
September 17, 2005
Version 4.0.68. Minor update

- [.NET, VCL] (OpenPGP) Fixed a problem with decrypting a file which was both encrypted and signed
- [All] (SSH) Fixed a couple of minor bugs

---
August 26, 2005
Version 4.0.67. Minor update

- [VCL] Fixed a problem with setting the license key in evaluation version
- [.NET] Fixed minor S/MIME problem with EncryptAndSign operation

---
August 15, 2005
Version 4.0.66. Internal build

- [VCL] (SSH) Fixed compatibility with Mocana server

---
August 15, 2005
Version 4.0.65. Official release

! MegaBlackbox has been renamed to SecureBlackbox Standard
! License keys have been changed (.NET and ActiveX editions)

+ [.NET, VCL] (PKI) Added OCSP components

---
July 20, 2005
Version 4.0.64. Beta version

+ [All] (SSL) TLS 1.1 support added
+ [All] (SSL) SimpleSSLClient component added
+ [.NET] (SSH) Added SSH server components
+ [.NET] (SSH) Added SFTP server components
+ [.NET] (MIME) Added DomainKeys for .NET

+ [.NET, VCL] (SSL) Added support for cipher renegotiation
+ [.NET, VCL] (SSL) Added OnError event
+ [.NET, VCL] (OpenPGP) Added RIPEMD and SHA 256/384/512 algorithms support
+ [.NET, VCL] (PKI) Added PKCS#5 and PKCS#8 support
+ [.NET, VCL] (PKI) TElGeneralName class got PermanentIdentifier member (RFC 4043)

- [.NET, VCL] (OpenPGP) fixed a memory leak in decompression
- [VCL] (PKI) ElAuthenticodeVerifier.RemoveAuthenticode() method didn't work. Fixed.
- [VCL] (MIME) Fixed DomainKeys canonicalization and signing.

---
June 4, 2005
Version 3.3.63. Internal release.

---
May 9, 2005
Version 3.3.62. Minor update
+ [.NET] (OpenPGP) RSA keys didn't work. Fixed.

---
May 8, 2005
Version 3.3.61. Minor update
+ [AX] (PKI) Added SystemStores and PhysicalStores to ElWinCertStorage' DLL interface
+ [.NET, VCL] (MIME) Added SecureMail sample that shows how to use PGP/MIME and S/MIME
* [All] (SSH) Added a workaround for an RSA public key authentication bug in F-Secure SSH server
* [.NET, VCL] (MIME) Added support for non-S/MIME-compliant messages and messages with broken signature (before they were not unsigned, now they are unsigned with the warning about broken signature)

---
April 29, 2005
Version 3.3.60. Minor update
- [.NET] (MIME) Fixed a bug (introduced in build 59) which caused MIME parser to go to infinite loop
- [.NET] (SSH) Fixed a bug (introduced in build 59) when SimpleSSHClient didn't work correctly
- [.NET] (PKI) Fixed a very specific problem with certain Windows Certificate Storage operations failing on storages, other than CurrentUser

---
April 25, 2005
Version 3.3.59. Minor update

+ [All]  (PKI) Added support for HMAC and AuthenticatedData subtype to PKCS#7 messages
+ [All]  (PKI) Added support for SHA 256/384/512 as a hashing algorithm for ElMessageSigner
+ [.NET, VCL] (SSH) Added CommandList property to CommandSSHTunnel in SSH client
* [.NET, VCL] (MIME) Parsing speed significantly improved
* [VCL] (SSH, SFTP) SSH server now supports authentication using several authentication methods at once (using OnFurtherAuthNeeded event)
* [VCL] (SSH, SFTP) Improved worker loop (in SSH server handlers), which could cause 100% CPU load in certain cases
* [.NET, VCL] (OpenPGP) Implemented support for old PGP comment packet
* [.NET, VCL] (OpenPGP) Implemented support for PGP private/experimental packets
* [.NET, VCL] (OpenPGP) ElPGPKeyring class made thread-safe
- [All]  (PKI) The library didn't work correctly with keys with integer length, which had a number of bytes, not divisible by 4.
- [.NET, VCL] (MIME) Fixed an issue with duplicate charset writing of the message part.
- [.NET, VCL] (MIME) Charset was added/changed also when assemling from source. Fixed.
- [.NET, VCL] (MIME) SMIME handler didn't handle encrypted multi-part messages. Fixed.
- [All] (SSH, SFTP) SSH key class was improved to strip leading zeros from key's long integer values
- [VCL] (SSH, SFTP) SSH server incorrectly reported public-key algorithms, for which it didn't have keys. Fixed.
- [VCL] (SSH, SFTP) Fixed a problem in SFTP client (which could set) and SFTP server (which didn't understand) file type value of 0. Now FileType of ftFile is always set for default attributes on the client and now 0 is treated as ftFile on the server.
- [VCL] (SFTP) SFTP server incorrectly handled invalid directory names. Fixed.
- [VCL] (SFTP) TElSFTPSSHSubsystemHandler.Execute caused 100% CPU load. Fixed.
- [VCL] (SSH) TElCustomSocketForwardingSSHSubsystemHandler.Execute caused 100% CPU load. Fixed.


---
April 10, 2005
Version 3.3.58. Minor update
- [.NET] (All) AES encryption fixed (AES192 and AES256 didn't work due to specifics of .NET assembly linker).

---
April 5, 2005
Version 3.3.57. Minor update
+ [All]  (SSH, SFTP) ElSimple*Client components got SOCKS and WebTunneling support
+ [All]  (SSH, SFTP) ElSimple*Client components support socket timeouts now
+ [All]  (SFTP) DownloadFile and UploadFile methods were added to ElSimple*Client component
+ [AX]   (All) Helper classes for array transformations and binary file read/write operations were added
+ [AX]   (SSH) Added support for dynamic tunnels (SSH 2 only)
+ [.NET, VCL] (MIME) EncoderSignTime and DecoderSignTime properties were added to TElMessageHandlerSMIME class
* [VCL]  (SSL) ICS HTTPS Client has been fixed to work around recent ICS addition, which was made to prevent use of external (to ICS) SSL solutions like SecureBlackbox.
* [VCL]  (SFTP) Improved compatibility of SFTP server code (and sample) with third-party clients (PuTTY and OpenSSH)
- [.NET] (PKI) Fixed GetIssuerCertificate method which could produce OutOfRangeException
- [.NET] (PKI) Fixed X509Certificate.DecryptWin32 metod (the bug which made it impossible to decrypt the data with Windows-contained certificate with non-exportable private key)
- [.NET] (MIME) Fixed verification of S/MIME signed messages
- [AX]   (PKI) Wrapper folder (necessary for DLL usage) was missing from PKIBlackbox installation.


---
Version 3.3.56. Major update
+ [All]  (PKI) Added CRL property to ElCustomCertStorage for easier validation of the certificates
+ [VCL]  (MIME) DomainKeys support added
+ [.NET] (OpenPGP) VB.NET samples for PGP.NET were added.
+ [.NET] (SSL) RemObjects.InternetPack classes and samples added.
+ [.NET] (SSL) RemObjects SDK.NET samples added.
+ [VCL]  (SSL) NexusDB 2 SSL transport and demo added.
* [AX]         Controls have been split into new libraries.
- [.NET] (SSH, SFTP) Use of built-in socket sometimes caused 100% load and dramatic slowdown of operations. Fixed.
- [.NET] (PKI) Large (over 65K) ASN.1 sequences could not be parsed. This bug mainly affected Certificate Revokation Lists. Fixed.
- [.NET] (MIME) Parsing of some multipart messages was done wrong. Fixed.
- [All]  (SSL) Fixed a problem with client-side certificates in SSL3 (when both SSL3 and TLS1 were enabled with SSL3 being active).
- [All]  (PKI) TElX509Certificate didn't correctly handle certain PEM files. Fixed.
- [All]  (PKI) TElMessageDecryptor couldn't decrypt the data with certificate stored in WinCertStorage, if the private key couldn't be exported. Fixed.
- [VCL]  (SFTP) Various fixes in SFTP server

---
Version 3.2.55. Minor update
+ [.NET] (OpenPGP) Various PGP.NET bugs fixed.
+ [VCL] (SSH) SSH Server improved.
+ [VCL] (SFTP) SFTP Server added.
+ [All] (PKI) Added PEM format to CRL
+ [All] (PKI) Added a sample for Certificate Request generation
* [VCL] (SSL) RemObjects demo was updated for RemObjects 3 for VCL
* [VCL] (SSL) Indy demos (client and server) were updated for Indy 10
- [.NET, VCL] (MIME) XMailer header was not set in certain cases. Fixed.
- [All] (SSH, SFTP) if Simple*Client component failed to connect, next connection attempt would fail. Fixed.

---
Version 3.2.54. Minor update

+ [ALL] (SFTP) Added internal socket support to SimpleSSHClient and SimpleSFTPClient components. Now one must not necessarily provide own socket object (although this is possible).
+ [.NET] (OpenPGP) PGP.NET beta is avaialble. Compression doesn't work in this beta.
+ [VCL] (SSH) SSH Server beta is available. Documentation is missing from this beta.
- [ALL] (PKI) Fixed a memory leak in CRL class.
